=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2007-11-28 21:55:07 +0000
+++ bzrlib/repofmt/pack_repo.py	2007-11-30 15:59:02 +0000
@@ -1033,7 +1033,8 @@
     def ensure_loaded(self):
         # NB: if you see an assertion error here, its probably access against
         # an unlocked repo. Naughty.
-        assert self.repo.is_locked()
+        if not self.repo.is_locked():
+            raise errors.ObjectNotLocked(self.repo)
         if self._names is None:
             self._names = {}
             self._packs_at_load = set()
@@ -1569,7 +1570,8 @@
         :returns: an iterator yielding tuples of (revison-id, parents-in-index,
             parents-in-revision).
         """
-        assert self.is_locked()
+        if not self.is_locked():
+            raise errors.ObjectNotLocked(self)
         pb = ui.ui_factory.nested_progress_bar()
         result = []
         try:

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2007-11-27 20:35:02 +0000
+++ bzrlib/tests/test_repository.py	2007-11-30 15:59:02 +0000
@@ -1195,7 +1195,13 @@
         repo = self.make_repository('.', format=format)
         packs = repo._pack_collection
         self.assertEqual([0], packs.pack_distribution(0))
-        
+
+    def test_ensure_loaded_unlocked(self):
+        format = self.get_format()
+        repo = self.make_repository('.', format=format)
+        self.assertRaises(errors.ObjectNotLocked,
+                          repo._pack_collection.ensure_loaded)
+
     def test_pack_distribution_one_to_nine(self):
         format = self.get_format()
         repo = self.make_repository('.', format=format)

